package com.example.autorization.ui.fragments.signup

import android.os.Bundle
import android.text.InputType
import androidx.fragment.app.Fragment
import android.view.MotionEvent
import android.view.View
import android.widget.Button
import android.widget.CheckBox
import android.widget.EditText
import android.widget.Toast
import androidx.core.widget.doOnTextChanged
import androidx.fragment.app.viewModels
import com.example.autorization.R

class SignUpScreen : Fragment(R.layout.fragment_sign_up_screen) {
    
    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        val viewModel by viewModels<SignUpViewModel> ()
        val passwordEditText =  view.findViewById<EditText>(R.id.PasswordEditText)
        val termsCheckBox = view.findViewById<CheckBox>(R.id.TarmsAndPolicyCheckBox)
        val createButton = view.findViewById<Button>(R.id.CreateAccountButton)
        var passwordIsVisible = false

        passwordEditText.doOnTextChanged { text, start, before, count ->
            viewModel.setLogin(text.toString())
        }

        viewModel.signUpState.observeForever{ it ->
            createButton.isEnabled = it.acceptTerms
        }

        termsCheckBox.setOnCheckedChangeListener { buttonView, isChecked ->
            viewModel.changeTerms(isChecked)
        }




        passwordEditText.setOnTouchListener { v, event ->
            if(event.action == MotionEvent.ACTION_UP){
                if(event.rawX >= passwordEditText.right -
                    passwordEditText.compoundDrawables[2].bounds.width()
                    - passwordEditText.paddingEnd){
                   passwordIsVisible = !passwordIsVisible
                    if(passwordIsVisible){
                        passwordEditText.inputType = InputType.TYPE_CLASS_TEXT or
                        InputType.TYPE_TEXT_VARIATION_VISIBLE_PASSWORD
                    }else{
                        passwordEditText.inputType = InputType.TYPE_CLASS_TEXT or
                                InputType.TYPE_TEXT_VARIATION_PASSWORD
                    }
                }
            }
            false
        }

    }

}